/*
 * ffmpeg_stub.h
 * Copyright (C) 2010 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __FFMPEG_STUB_H__
#define __FFMPEG_STUB_H__

#ifndef OLD
#include <libavutil/opt.h>
#endif
#include <libavformat/avformat.h>
#include <libswscale/swscale.h>

extern int ffmpeg_stub_valid;

extern AVCodec *__mp3_decoder;
extern AVCodec *__ac3_decoder;
extern AVCodec *__flac_decoder;
extern AVCodec *__mpc7_decoder;

#define DECL(sym) extern typeof(sym) *__##sym;
#include "symbols/avutil.h"
#include "symbols/avcodec.h"
#include "symbols/avformat.h"
#include "symbols/swscale.h"
#undef DECL

int ffmpeg_stub_load(const char *path, char *p, void (*error)(char *));
int ffmpeg_stub_unload();

#endif // __FFMPEG_STUB_H__
