/*
 * libmad_stub.c
 * Copyright (C) 2010 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <stdio.h>
#include <windows.h>
#include "libmad_stub.h"

int mad_stub_valid=0;
static HINSTANCE hLibMAD=NULL;

#define DECL(sym) typeof(sym) *__##sym;
#include "symbols/libmad.h"
#undef DECL

#define DECL(sym) \
  if (NULL==(__##sym=(void *)GetProcAddress(H_LIB, #sym))) \
    goto fail;

int mad_stub_load(const char *path, char *p)
{
  strcpy(p, "in_ffsox\\libmad.dll");

#define H_LIB hLibMAD
  if (NULL==(H_LIB=LoadLibrary(TEXT(path))))
    goto fail;

#include "symbols/libmad.h"
#undef H_LIB

fprintf(stderr, "LIBMAD SUCCESS ...\n");
  return mad_stub_valid=1;
fail:
fprintf(stderr, "LIBMAD FAIL ...\n");
  return mad_stub_unload();
}

#undef DECL

int mad_stub_unload()
{
  if (NULL!=hLibMAD) {
    FreeLibrary(hLibMAD);
    hLibMAD=NULL;
  }

  return mad_stub_valid=0;
}
