#include "plugin.h"
#include "strbuf.h"

strbuf_t *strbuf_open(strbuf_t *buf, size_t size)
{
  if (NULL==(buf->buf=malloc(size)))
    return NULL;

  buf->wp=buf->buf;
  buf->mp=buf->buf+size;

  return buf;
}

strbuf_t *strbuf_close(strbuf_t *buf)
{
  if (NULL!=buf->buf)
    free((void *)buf->buf);

  return buf;
}

void strbuf_putc(strbuf_t *buf, char ch)
{
  if (buf->wp+1==buf->mp) {
    int offs=buf->wp-buf->buf;
    int size=2*(buf->mp-buf->buf);

    buf->buf=realloc(buf->buf,size);
    buf->wp=buf->buf+offs;
    buf->mp=buf->buf+size;
  }

  *buf->wp++=ch;
}

void strbuf_wchar2utf8(strbuf_t *buf, int page, const wchar_t *wch)
{
/*
int WideCharToMultiByte(
  UINT CodePage, 
  DWORD dwFlags, 
  LPCWSTR lpWideCharStr, 
  int cchWideChar, 
  LPSTR lpMultiByteStr, 
  int cbMultiByte, 
  LPCSTR lpDefaultChar, 
  LPBOOL lpUsedDefaultChar 
);
*/
  int n=WideCharToMultiByte(page,0,wch,-1,NULL,0,NULL,NULL);

  if (buf->mp-buf->buf<n) {
    buf->buf=realloc((void *)buf->buf, n*sizeof(buf->buf[0]));
    buf->mp=buf->buf+n;
  }

  WideCharToMultiByte(page,0,wch,-1,(char *)buf->buf,n,NULL,NULL);
  buf->wp=buf->buf+n;
/*
  buf->wp=buf->buf;

  if (NULL!=wch) {
    while (*wch) {
      if (*wch < 0x80)
        strbuf_putc(buf, *wch++);
      else if (*wch < 0x800) {
        strbuf_putc(buf, 0xc0 | ((*wch >> 6) & 0x1f));
        strbuf_putc(buf, 0x80 | (*wch++ & 0x3f));
      }
      else {
        strbuf_putc(buf, 0xe0 | ((*wch >> 12) & 0xf));
        strbuf_putc(buf, 0x80 | ((*wch >> 6) & 0x3f));
        strbuf_putc(buf, 0x80 | (*wch++ & 0x3f));
      }
    }
  }

  strbuf_putc(buf, 0);
*/
}

wstrbuf_t *wstrbuf_open(wstrbuf_t *buf, size_t size)
{
  if (NULL==(buf->buf=malloc(size*sizeof buf->buf[0])))
    return NULL;

  buf->wp=buf->buf;
  buf->mp=buf->buf+size;

  return buf;
}

wstrbuf_t *wstrbuf_close(wstrbuf_t *buf)
{
  if (NULL!=buf->buf)
    free((void *)buf->buf);

  return buf;
}

static void wstrbuf_inc(wstrbuf_t *buf)
{
  if (++buf->wp==buf->mp) {
    int m=buf->wp-buf->buf;
    int n=2*(buf->mp-buf->buf);

    buf->buf=realloc((void *)buf->buf, n*sizeof(buf->buf[0]));
    buf->wp=buf->buf+m;
    buf->mp=buf->buf+n;
  }
}

void wstrbuf_utf82wchar(wstrbuf_t *buf, int page, const char *str)
{
  int n=MultiByteToWideChar(page,0,str,-1,NULL,0);

  if (buf->mp-buf->buf<n) {
    buf->buf=realloc((void *)buf->buf, n*sizeof(buf->buf[0]));
    buf->mp=buf->buf+n;
  }

  MultiByteToWideChar(page,0,str,-1,(wchar_t *)buf->buf,n);
  buf->wp=buf->buf+n;
}
