#ifndef __STRBUF_H__
#define __STRBUF_H__

#include <windows.h>
#include <stdlib.h>

typedef struct strbuf {
  volatile char *buf;
  volatile char *wp;
  volatile char *mp;
} strbuf_t;

strbuf_t *strbuf_open(strbuf_t *buf, size_t size);
strbuf_t *strbuf_close(strbuf_t *buf);

void strbuf_putc(strbuf_t *buf, char ch);
void strbuf_wchar2utf8(strbuf_t *buf, int page, const wchar_t *wch);

typedef struct wstrbuf {
  volatile wchar_t *buf;
  volatile wchar_t *wp;
  volatile wchar_t *mp;
} wstrbuf_t;

wstrbuf_t *wstrbuf_open(wstrbuf_t *buf, size_t size);
wstrbuf_t *wstrbuf_close(wstrbuf_t *buf);

void wstrbuf_utf82wchar(wstrbuf_t *buf, int page, const char *str);

#endif // __STRBUF_H__
