#include "tab.h"

void tab_init(tab_t *tab, HWND hDlg)
{
    RECT rc;
    TCITEM tabPage;
    HWND hTab=GetDlgItem(hDlg,tab->id);
    tab_page_t *cur;

    GetWindowRect(hTab,&rc); 

    memset(&tabPage,0,sizeof tabPage);
    tabPage.mask=TCIF_TEXT;

    for (cur=tab->pages; NULL!=cur->title; ++cur) {
      HRSRC hrsrc=FindResource(NULL,MAKEINTRESOURCE(cur->id),RT_DIALOG);
      HGLOBAL hglb=LoadResource(GetModuleHandle(NULL),hrsrc);
      DLGTEMPLATE *res=(DLGTEMPLATE *)LockResource(hglb);

      tabPage.pszText=cur->title;
      TabCtrl_InsertItem(hTab,cur-tab->pages,&tabPage);
      cur->hDlg=CreateDialogIndirect(GetModuleHandle(NULL), 
          res,hTab,cur->proc); 
      SetWindowPos(cur->hDlg,HWND_TOP,rc.left,rc.top,0,0,SWP_NOSIZE);
    }

    tab_change(tab,hDlg);
}

void tab_change(tab_t *tab, HWND hDlg) 
{ 
  HWND hTab=GetDlgItem(hDlg,tab->id);
  tab_page_t *cur=tab->pages+TabCtrl_GetCurSel(hTab); 
 
  if (tab->hCurPage!=NULL) 
    ShowWindow(tab->hCurPage,SW_HIDE);
 
  tab->hCurPage=cur->hDlg;
  ShowWindow(tab->hCurPage,SW_SHOW);
}
